--  C:\HDL\FNDISEWORK\SAMPLE\...\LCDOPESM.vhd
--  VHDL code created by Xilinx's StateCAD 8.1i
--  Fri May 12 09:25:49 2006

--  This VHDL code (for use with IEEE compliant tools) was generated using: 
--  enumerated state assignment with structured code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are speed optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY LCDOPESM IS
	PORT (CLK,access4bit,ope_start,operation_end,RESET,U2L_interval_end: IN 
		std_logic;
		lcd_e,ope_is_idle,sel_lower,U2L_interval_ena : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF LCDOPESM IS
	TYPE type_sreg IS (idle_main,lower_end_wait,lower_start,upper_end_wait,
		upper_start,wait_1us);
	SIGNAL sreg, next_sreg : type_sreg;
	TYPE type_sreg1 IS (idle_nibble,operation);
	SIGNAL sreg1, next_sreg1 : type_sreg1;
	SIGNAL next_lcd_e,next_sel_lower,next_U2L_interval_ena : std_logic;
BEGIN
	PROCESS (CLK, RESET, next_sreg, next_sel_lower, next_U2L_interval_ena)
	BEGIN
		IF ( RESET='1' ) THEN
			sreg <= idle_main;
			sel_lower <= '0';
			U2L_interval_ena <= '0';
		ELSIF CLK='1' AND CLK'event THEN
			sreg <= next_sreg;
			sel_lower <= next_sel_lower;
			U2L_interval_ena <= next_U2L_interval_ena;
		END IF;
	END PROCESS;

	PROCESS (CLK, RESET, next_sreg1, next_lcd_e)
	BEGIN
		IF ( RESET='1' ) THEN
			sreg1 <= idle_nibble;
			lcd_e <= '0';
		ELSIF CLK='1' AND CLK'event THEN
			sreg1 <= next_sreg1;
			lcd_e <= next_lcd_e;
		END IF;
	END PROCESS;

	PROCESS (sreg,sreg1,access4bit,ope_start,operation_end,U2L_interval_end)
	BEGIN
		next_lcd_e <= '0'; next_sel_lower <= '0'; next_U2L_interval_ena <= '0'; 

		next_sreg<=idle_main;
		next_sreg1<=idle_nibble;

		CASE sreg IS
			WHEN idle_main =>
				IF ( ope_start='1' AND access4bit='1' ) THEN
					next_sreg<=lower_start;
					next_U2L_interval_ena<='0';
					next_sel_lower<='1';
				END IF;
				IF ( ope_start='1' AND access4bit='0' ) THEN
					next_sreg<=upper_start;
					next_U2L_interval_ena<='0';
					next_sel_lower<='0';
				END IF;
				IF ( ope_start='0' ) THEN
					next_sreg<=idle_main;
					next_U2L_interval_ena<='0';
					next_sel_lower<='0';
				END IF;
			WHEN lower_end_wait =>
				IF (  (sreg1=idle_nibble)) THEN
					next_sreg<=idle_main;
					next_U2L_interval_ena<='0';
					next_sel_lower<='0';
				 ELSE
					next_sreg<=lower_end_wait;
					next_U2L_interval_ena<='0';
					next_sel_lower<='1';
				END IF;
			WHEN lower_start =>
				next_sreg<=lower_end_wait;
				next_U2L_interval_ena<='0';
				next_sel_lower<='1';
			WHEN upper_end_wait =>
				IF (  (sreg1=idle_nibble)) THEN
					next_sreg<=wait_1us;
					next_U2L_interval_ena<='1';
					next_sel_lower<='1';
				 ELSE
					next_sreg<=upper_end_wait;
					next_U2L_interval_ena<='0';
					next_sel_lower<='0';
				END IF;
			WHEN upper_start =>
				next_sreg<=upper_end_wait;
				next_U2L_interval_ena<='0';
				next_sel_lower<='0';
			WHEN wait_1us =>
				IF ( U2L_interval_end='1' ) THEN
					next_sreg<=lower_start;
					next_U2L_interval_ena<='0';
					next_sel_lower<='1';
				 ELSE
					next_sreg<=wait_1us;
					next_U2L_interval_ena<='1';
					next_sel_lower<='1';
				END IF;
			WHEN OTHERS =>
		END CASE;

		CASE sreg1 IS
			WHEN idle_nibble =>
				IF (  (sreg=upper_start)) OR (  (sreg=lower_start)) THEN
					next_sreg1<=operation;
					next_lcd_e<='1';
				 ELSE
					next_sreg1<=idle_nibble;
					next_lcd_e<='0';
				END IF;
			WHEN operation =>
				IF ( operation_end='1' ) THEN
					next_sreg1<=idle_nibble;
					next_lcd_e<='0';
				 ELSE
					next_sreg1<=operation;
					next_lcd_e<='1';
				END IF;
			WHEN OTHERS =>
		END CASE;
	END PROCESS;

	PROCESS (sreg)
	BEGIN
		IF ((  (sreg=idle_main))) THEN ope_is_idle<='1';
		ELSE ope_is_idle<='0';
		END IF;
	END PROCESS;
END BEHAVIOR;
