--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 8.1.03i
--  \   \         Application : ISE
--  /   /         Filename : Test_LCD4HexDisp.vhw
-- /___/   /\     Timestamp : Fri May 05 05:49:23 2006
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: Test_LCD4HexDisp
--Device: Xilinx
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
    COMPONENT Test_LCD4HexDisp
        PORT (
            clk : In std_logic;
            reset : In std_logic;
            lcd_d : InOut std_logic_vector (7 DownTo 4);
            lcd_rs : Out std_logic;
            lcd_rw : Out std_logic;
            lcd_e : Out std_logic
        );
    END COMPONENT;

    SIGNAL clk : std_logic := '0';
    SIGNAL reset : std_logic := '0';
    SIGNAL lcd_d : std_logic_vector (7 DownTo 4) := "0000";
    SIGNAL lcd_rs : std_logic := '0';
    SIGNAL lcd_rw : std_logic := '0';
    SIGNAL lcd_e : std_logic := '0';

    SHARED VARIABLE TX_ERROR : INTEGER := 0;
    SHARED VARIABLE TX_OUT : LINE;

    constant PERIOD : time := 20 ns;
    constant DUTY_CYCLE : real := 0.5;
    constant OFFSET : time := 0 ns;

    BEGIN
        UUT : Test_LCD4HexDisp
        PORT MAP (
            clk => clk,
            reset => reset,
            lcd_d => lcd_d,
            lcd_rs => lcd_rs,
            lcd_rw => lcd_rw,
            lcd_e => lcd_e
        );

        PROCESS    -- clock process for clk
        BEGIN
            WAIT for OFFSET;
            CLOCK_LOOP : LOOP
                clk <= '0';
                WAIT FOR (PERIOD - (PERIOD * DUTY_CYCLE));
                clk <= '1';
                WAIT FOR (PERIOD * DUTY_CYCLE);
            END LOOP CLOCK_LOOP;
        END PROCESS;

		reset <= '1',
					'0' after 15 ns;
    END testbench_arch;

configuration Test_LCD4HexDisp_cfg of testbench is
	for testbench_arch
	end for;
end Test_LCD4HexDisp_cfg;
