-- LCD Operation State Machine
-- lcd_rw, lcd_rs, access4bit, r_w, wr_data, port0_w_strobe, port1_w_strobeȂǂ̓b`M͂邱ƂɂB

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library work;
use work.LCD_Display_pack.all;

entity LCD_operation is
	port(
		clk : in std_logic;
		reset : in std_logic;
		access4bit : in std_logic; -- 4rbgANZXp
		port1_w_strobe : in std_logic; -- f[^PicoBlaze珑
		lcd_e : out std_logic; -- LCD_EMALCDɋ
		ope_is_idle : out std_logic; -- upper,lower4bitLCDɏݏI
		sel_lower : out std_logic -- lower4bitݒ
	);
end LCD_operation;

architecture RTL of LCD_operation is
component LCDOPESM
	PORT (CLK,reset,ope_start,operation_end,U2L_interval_end, access4bit: IN std_logic;
		lcd_e,ope_is_idle,U2L_interval_ena,sel_lower : OUT std_logic);
END component;

signal u2l_cnt : std_logic_vector(6 downto 0);
signal u2l_cnt_ena  : std_logic;
signal ope_pulse_cnt : std_logic_vector(3 downto 0);
signal lcd_e_node, doing_ope : std_logic;
begin
	-- upper 4bitlower 4bitԂ1usv^C}[(1.28us)
	process(reset, clk) begin
		if reset='1' then
			u2l_cnt <= (others => '0');
		elsif clk'event and clk='1' then
			if u2l_cnt_ena='1' then
				u2l_cnt <= u2l_cnt + 1;
			else
				u2l_cnt <= (others => '0');
			end if;
		end if;
	end process;
	
	-- ݁AǂݏopX140nŝ߂8(ۂ160ns)
	process(reset, clk) begin
		if reset='1' then
			ope_pulse_cnt <= (others => '0');
		elsif clk'event and clk='1' then
			if doing_ope='1' then
				ope_pulse_cnt <= ope_pulse_cnt + 1;
			else
				ope_pulse_cnt <= (others => '0');
			end if;
		end if;
	end process;
	
	lcdopesm_inst : lcdopesm port map(
		clk => clk,
		reset => reset,
		ope_start => port1_w_strobe,
		operation_end => ope_pulse_cnt(ope_pulse_cnt'left),
		U2L_interval_end => u2l_cnt(u2l_cnt'left),
		access4bit => access4bit,
		lcd_e => lcd_e_node,
		ope_is_idle => ope_is_idle,
		U2L_interval_ena => u2l_cnt_ena,
		sel_lower => sel_lower
	);
	doing_ope <= lcd_e_node;
	lcd_e <= lcd_e_node;
end RTL;
