-- LCD4HexDisp̃eXgp

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Test_LCD4HexDisp is
	port(
		clk : in std_logic;
		reset : in std_logic;
		lcd_d : inout std_logic_vector(7 downto 4);
		lcd_rs : out std_logic;
		lcd_rw : out std_logic;
		lcd_e : out std_logic;
		sf_ce0 : out std_logic
	);
end Test_LCD4HexDisp;

architecture RTL of Test_LCD4HexDisp is
signal upper_4hex_data : std_logic_vector(15 downto 0); -- LCD̍s416i
signal lower_4hex_data : std_logic_vector(15 downto 0); -- LCD̍s416i
component LCD4HexDisp
	port(
		clk : in std_logic;
		reset : in std_logic;
		upper_4hex_data : in std_logic_vector(15 downto 0); -- LCD̍s416i
		lower_4hex_data : in std_logic_vector(15 downto 0); -- LCD̍s416i
		lcd_d : inout std_logic_vector(7 downto 4);
		lcd_rs : out std_logic;
		lcd_rw : out std_logic;
		lcd_e : out std_logic
	);
end component;
begin
	sf_ce0 <= '1';
	upper_4hex_data <= X"9ABC";
	lower_4hex_data <= X"DEF0";
	
	LCD4HexDisp_inst : LCD4HexDisp port map(
		clk => clk,
		reset => reset,
		upper_4hex_data => upper_4hex_data,
		lower_4hex_data => lower_4hex_data,
		lcd_d => lcd_d,
		lcd_rs => lcd_rs,
		lcd_rw => lcd_rw,
		lcd_e => lcd_e
	);
end RTL;
